'Okay let me explain what a pointer is first off.
'A pointer is basically an address of a variable.  Let's
'say I have allocated memory for an Integer...
  'Dim Var1 as Integer
  'Var1 = 193
'Now that variable "Var1" has it's own specific memory
'address.  Now a pointer would essentially 'point' to
'that address.  So now we'll set up a new variable that
'will be that pointer, I won't go into exact code
'this will be more of a worded diagram.
  'Var2 = Pointer To (Var1)
'So now the variable "Var2" is the pointer to the memory
'address of "Var1".  So now you're probably thinking
'okay so now Var2 is equal to Var1's value (193).
'WRONG!!!  Var2 is only a pointer to the memory address.
'There is one more step in dealing with pointers.  You're
'going to have to "Dereference" them.  This means to
'get the data contained in the variable the pointer
'points to, so we'll set up a new variable to contain that
'data.
   'Var3 = Dereference (Var2)
'So now var3 would be equal to the data in Var1 (193).
Option Explicit
Declare Function VarPtr Lib "VBRUN300.DLL" Alias "VARPTR" (Var1 As Any) As Long 'The function that sets either an Integer Pointer or a Long-Integer...NEVER use String here.
Declare Function StrPtr Lib "VBRUN300.DLL" Alias "VARPTR" (Str_Var1 As String) As Long 'This function will set a string pointer.
Declare Sub hmemcpy Lib "Kernel" (ByVal hpvDest As Any, ByVal hpvSource As Any, ByVal nBytes As Long) 'And this is the function that dereferences the pointer.

Function Integer_Pointer (Var1 As Integer) As Integer
If Len(Var1) = 0 Then Exit Function'If there is no data to point to stop processing.
Dim Var2 As Long
Dim Var3 As Integer
Var2 = VarPtr(Var1) 'Get pointer to Var1
hmemcpy VarPtr(Var3), Var2, Len(Var1)'Dereference the pointer
'The first param gets the address of the destination variable.
'The second param gives the source pointer.
'The third param gives you the number of bytes to copy from the source.

Integer_Pointer = Var3
End Function

Function String_Pointer (Str_Var1 As String) As String
If Len(Str_Var1) = 0 Then Exit Function'If there is no data to point to stop processing.
Dim Str_Var2 As Long 'Declare variables
Dim Str_Var3 As String
Str_Var2 = StrPtr(Str_Var1) 'Str_Var2 now points to the memory address of Str_Var1
Str_Var3 = Space$(Len(Str_Var1))'Create a buffer large enough to hold the data in Str_Var1
hmemcpy StrPtr(Str_Var3), Str_Var2, Len(Str_Var1)
'The first param gets the address of the destination variable.
'The second param gives the source pointer.
'The third param gives you the number of bytes to copy from the source.

String_Pointer = Str_Var3
End Function

